#!/bin/bash
clear
echo "################################"
echo "   SpamScan plugin Installation"
echo "################################"
dpath=/usr/local/cpanel/whostmgr/cgi/spamscan
dloc=/usr/local/cpanel/whostmgr/cgi
spath=/usr/local/cpanel/base/frontend/x3/spamscan
pvs=$(/usr/local/cpanel/3rdparty/bin/php -v | head -1 | awk '{print $2}' | awk -F. '{print $1$2}')
cpv=$(/usr/local/cpanel/cpanel -V | head -1 |  awk -F. {'print $2'})
export who=`whoami`
if [[ $who == "root" ]];then
echo "Installation proceedings....."
sleep 2

echo "Checking Support modules....."
chk=$(grep -r "ioncube" /usr/local/cpanel/3rdparty/etc/php.ini | cut -d'=' -f1)
curlchk=$(/usr/local/cpanel/3rdparty/bin/php -i | grep cURL)
if [ "$chk" == "" ]; then
        echo "IonCube Loader is not installed, Please install WHM->Tweak Settings->PHP"
        if [ "$curlchk" == "" ];then
        echo "cURL is not Installed. Please install cURL in your server PHP and run /scripts/makecpphp to update cpanel PHP"
        fi
exit 0
else
echo "IonCube Loader is Installed"
        if [ "$curlchk" == "" ];then
        echo "cURL is not Installed. Please install cURL in your server PHP and run /scripts/makecpphp to update cpanel PHP"
exit 0
        else
        echo "cURL is Installed"
        fi
fi


if [ -d "$dpath" ];then
echo "Plugin already installed !"
exit 1
else

echo -n "Enter Your SpamScan License Key: "
read licen
if [ "$licen" == "" ]; then
        echo -n "Enter valid license key: "
        read licen
        if [ "$licen" == "" ]; then
          echo "License Key should not be empty.. Exit!!"
          exit 0
        else
          echo $licen > ./php53/spamscan/licensekey.txt
          echo $licen > ./php52/spamscan/licensekey.txt
          echo $licen > ./php54/spamscan/licensekey.txt
        fi
else
echo $licen > ./php53/spamscan/licensekey.txt
echo $licen > ./php52/spamscan/licensekey.txt
echo $licen > ./php54/spamscan/licensekey.txt
fi


find $dloc -iname "addon_spamscan.cgi" -type f -exec /bin/mv {} /tmp \;
mv ./addon_spamscan.cgi $dloc
if [ $pvs -eq "52" ];then
mv php52/spamscan $dloc
else
	if [ $pvs -eq "53" ];then
	mv php53/spamscan $dloc
	else
	        if [ $pvs -eq "54" ];then
        	  mv php54/spamscan $dloc
	        else
		  echo "PHP Version Mismatch"
	  	  exit;
		fi
	fi
fi
cp -Rf /usr/local/cpanel/3rdparty/etc/php.ini $dloc/spamscan/

###WHM plugin Registration####

if [ "$cpv" -lt 38 ]; then
echo "Plugin registration is not needed"
else
        if [ ! -d "/var/cpanel/apps" ]; then
        mkdir /var/cpanel/apps
        chmod 755 /var/cpanel/apps
        /usr/local/cpanel/bin/register_appconfig addon_spamscan.conf
        else
        /usr/local/cpanel/bin/register_appconfig addon_spamscan.conf
        fi
fi


echo "WHM SpamScan plugin installation completed"
clear
#############################
#cPanel Plugin Installation #
#############################
if [ -d "$spath" ];then
mv $spath $spath.$d
fi
echo "SpamScan cPanel plugin installation started"
if [ $pvs -eq "52" ];then
/usr/bin/rsync -avz  php52/cpanel/spamscan /usr/local/cpanel/base/frontend/x3
else
	if [ $pvs -eq "53" ];then
	/usr/bin/rsync -avz  php53/cpanel/spamscan /usr/local/cpanel/base/frontend/x3
	else
	        if [ $pvs -eq "54" ];then
        	  /usr/bin/rsync -avz  php54/cpanel/spamscan /usr/local/cpanel/base/frontend/x3
	        else
		  echo "PHP Version Mismatch"
		  exit;
		fi
	fi
fi
/usr/bin/rsync -avz ./spamscan.cpanelplugin /usr/local/cpanel/3rdparty/
/usr/local/cpanel/bin/register_cpanelplugin ./spamscan.cpanelplugin

for dname in `ls /usr/local/cpanel/base/frontend`
do
if [ -d "/usr/local/cpanel/base/frontend/$dname" ];then
        if [ "$dname" != "x3" ];then
                if [ -h /usr/local/cpanel/base/frontend/$dname ]; then
                        echo "";
                else
                rm -rf /usr/local/cpanel/base/frontend/$dname/spamscan;
                ln -s /usr/local/cpanel/base/frontend/x3/spamscan /usr/local/cpanel/base/frontend/$dname/spamscan
                fi
        fi
fi
done

echo '*/5 1 * * * /usr/local/cpanel/3rdparty/bin/php /usr/local/cpanel/whostmgr/cgi/spamscan/spamscan_cron.php' >> /var/spool/cron/root
echo "Cron Settings updated"
/etc/init.d/crond restart
echo "Spam Scanning process initiated.... This may take a while, please be patient "
/usr/local/cpanel/3rdparty/bin/php /usr/local/cpanel/whostmgr/cgi/spamscan/spamscan_cron.php
echo "Scanning process completed. Login WHM -> Plugins"
rm -rf ../spamscan
##############################################
echo "SpamScan Installation Completed"
##############################################
fi
else
echo "You need root user privileges to continue Installation"
exit 1
fi
